
var domUtil={addEvent:domUtil_addEvent,removeEvent:domUtil_removeEvent}
function domUtil_addEvent(element,eventName,func){if(element.addEventListener){domUtil.addEvent=domUtil_addEventListener;}else if(element.attachEvent){domUtil.addEvent=domUtil_attachEvent;}else{domUtil.addEvent=new Function('return false');}
return domUtil.addEvent(element,eventName,func);}
function domUtil_addEventListener(element,eventName,func){element.addEventListener(eventName,func,false);return true;}
function domUtil_attachEvent(element,eventName,func){element.attachEvent('on'+eventName,func);return true;}
function domUtil_removeEvent(element,eventName,func){if(element.removeEventListener){domUtil.removeEvent=domUtil_removeEventListener;}else if(element.detachEvent){domUtil.removeEvent=domUtil_detachEvent;}else{return false;}
domUtil.removeEvent(element,eventName,func);return true;}
function domUtil_removeEventListener(element,eventName,func){element.removeEventListener(eventName,func,false);}
function domUtil_detachEvent(element,eventName,func){element.detachEvent('on'+eventName,func);}
function domUtil_removeAllChildNodes(element){return element?element.removeAllChildNodes():element;}
function domUtil_removeAllChildNodesById(id){return domUtil_removeAllChildNodes(document.getElementById(id));}
function domUtil_addClassName(element,addClassName){if(!element)return element;return element.addClass(addClassName);}
function domUtil_addClassNameById(id,addClassName){return domUtil_addClassName(document.getElementById(id),addClassName);}
function domUtil_removeClassName(element,removeClassName){if(!element)return element;return element.removeClass(removeClassName);}
function domUtil_removeClassNameById(id,removeClassName){return domUtil_removeClassName(document.getElementById(id),removeClassName);}
function domUtil_getFirstElementByName(name){if(name){var list=document.getElementsByName(name);if(list&&list.length)return list[0];}
return null;}
function domUtil_getFirstElementByTagName(tagName,root){if(tagName){var list=(root||document).getElementsByTagName(tagName);if(list&&list.length)return list[0];}
return null;}
function domUtil_generateElement(tagName,childNode,attributes,functions){var element=document.createElement(tagName);if(childNode)element.appendChild(childNode);if(attributes){for(var attName in attributes){element.setAttribute(attName,attributes[attName]);}}
if(functions){for(var eventName in functions){domUtil.addEvent(element,eventName,functions[eventName]);}}
return element;}
function domUtil_generateTextElement(tagName,text,attributes,functions){return domUtil_generateElement(tagName,domUtil_generateTextNode(text),attributes,functions);}
function domUtil_generateTextNode(text){if(null==text)text='';return document.createTextNode(text);}
function domUtil_generateOption(text,val,attributes){if(null==attributes)attributes={};attributes.value=val;return domUtil_generateElement('OPTION',domUtil_generateTextNode(text),attributes);}
function domUtil_generateSpan(childNode,attributes,functions){return domUtil_generateElement('SPAN',childNode,attributes,functions);}
function domUtil_generateTextSpan(text,attributes,functions){return domUtil_generateSpan(domUtil_generateTextNode(text),attributes,functions);}
function domUtil_generateAnchor(childNode,url,target,attributes,functions){if(null==attributes)attributes={};if(url)attributes.href=url;if(target)attributes.target=target;return domUtil_generateElement('A',childNode,attributes,functions);}
function domUtil_generateTextAnchor(text,url,target,attributes,functions){return domUtil_generateAnchor(domUtil_generateTextNode(text),url,target,attributes,functions);}
function domUtil_generateLabel(childNode,forId,attributes,functions){if(null==attributes)attributes={};if(forId)attributes['for']=forId;return domUtil_generateElement('LABEL',childNode,attributes,functions);}
function domUtil_generateTextLabel(text,forId,attributes,functions){return domUtil_generateLabel(domUtil_generateTextNode(text),forId,attributes,functions);}
function domUtil_generateCheckbox(val,groupName,checked,attributes,functions){if(null==attributes)attributes={};attributes.type='checkbox';attributes.value=val;if(groupName)attributes.name=groupName;if(checked)attributes.checked='checked';return domUtil_generateElement('INPUT',null,attributes,functions);}
function domUtil_generateRadio(val,groupName,checked,attributes,functions){if(null==attributes)attributes={};attributes.type='radio';attributes.name=groupName;attributes.value=val;if(checked)attributes.checked='checked';return domUtil_generateElement('INPUT',null,attributes,functions);}
function domUtil_getSelectedOption(element){if(element)return element.getSelectedOption();return null;}
function domUtil_getSelectedOptionById(id){return domUtil_getSelectedOption(document.getElementById(id));}
function domUtil_getSelectedOptionByName(name){var element=domUtil_getFirstElementByName(name);if(!element)return null;return domUtil_getSelectedOption(element);}
function domUtil_getSelectedOptionValue(element){var opt=domUtil_getSelectedOption(element);return opt?opt.value:opt;}
function domUtil_getSelectedOptionValueById(id){return domUtil_getSelectedOptionValue(document.getElementById(id));}
function domUtil_getSelectedOptionValueByName(name){var element=domUtil_getFirstElementByName(name);if(!element)return null;return domUtil_getSelectedOptionValue(element);}
function domUtil_getSelectedIndex(element){if(!element)return null;return element.selectedIndex;}
function domUtil_getSelectedIndexById(id){return domUtil_getSelectedIndex(document.getElementById(id));}
function domUtil_getSelectedRadio(radioButtons){if(!radioButtons||!radioButtons.length)return null;for(var i=0,len=radioButtons.length;i<len;i++){var radio=radioButtons[i];if(radio.checked)return radio;}
return null;}
function domUtil_getSelectedRadioByName(groupName){return domUtil_getSelectedRadio(document.getElementsByName(groupName));}
function domUtil_getSelectedRadioValue(radioButtons){var radio=domUtil_getSelectedRadio(radioButtons);return(radio?radio.value:null);}
function domUtil_getSelectedRadioValueByName(groupName){return domUtil_getSelectedRadioValue(document.getElementsByName(groupName));}
function domUtil_findRadio(radioButtons,val){if(!radioButtons||!radioButtons.length)return null;for(var i=0,len=radioButtons.length;i<len;i++){var radio=radioButtons[i];if(val===radio.value)return radio;}
return null;}
function domUtil_findRadioByName(groupName,val){return domUtil_findRadio(document.getElementsByName(groupName),val);}