
var narouCodeUtil={ALPHABET:'ABCDEFGHIJKLMNOPQRSTUVWXYZ',ALPHA_LEN:26,MAX_NUMBER:9999,pattern:{ALL:/^(N|X|X?S)(\d{4})([A-Z]+)$/,NCODE:/^(N)(\d{4})([A-Z]+)$/,XID:/^(X)(\d{4})([A-Z]+)$/,SCODE:/^(X?S)(\d{4})([A-Z]+)$/,NSCODE:/^(S)(\d{4})([A-Z]+)$/,XSCODE:/^(XS)(\d{4})([A-Z]+)$/},paddingZero:function(n){return("000"+n).slice(-4);},isXscode:null,parseCode:null,codeToNumberSub:null,codeToNumber:null,ncodeToNumber:null,xidToNumber:null,scodeToNumber:null,numberToCode:null}
narouCodeUtil.isXscode=function(code){if(!code)return false;return!!code.toUpperCase().match(narouCodeUtil.pattern.XSCODE);}
narouCodeUtil.parseCode=function(code,patternName){if(!code)return null;if(!patternName)patternName='ALL';var pattern=narouCodeUtil.pattern[patternName];if(!pattern)return null;code=code.toUpperCase();if(!code.match(pattern))return null;var result={};result.code=code;result.prefix=RegExp.$1;result.numText=RegExp.$2;result.num=Math.floor(result.numText);result.alpha=RegExp.$3;return result;}
narouCodeUtil.codeToNumberSub=function(code,patternName){var parseObj=narouCodeUtil.parseCode(code,patternName);if(!parseObj)return null;var alphabet=narouCodeUtil.ALPHABET;var alphaLen=narouCodeUtil.ALPHA_LEN;var max=narouCodeUtil.MAX_NUMBER;var alias=parseObj.num;var alphaArray=parseObj.alpha.split('').reverse();if(1<alphaArray.length&&'A'===alphaArray[alphaArray.length-1])return null;for(var i=0;i<alphaArray.length;i++){var index=alphabet.indexOf(alphaArray[i]);alias+=max*Math.pow(alphaLen,i)*index;}
return alias;}
narouCodeUtil.codeToNumber=function(code){return narouCodeUtil.codeToNumberSub(code,'ALL');}
narouCodeUtil.ncodeToNumber=function(ncode){return narouCodeUtil.codeToNumberSub(ncode,'NCODE');}
narouCodeUtil.xidToNumber=function(xid){return narouCodeUtil.codeToNumberSub(xid,'XID');}
narouCodeUtil.scodeToNumber=function(scode){return narouCodeUtil.codeToNumberSub(scode,'SCODE');}
narouCodeUtil.numberToCode=function(num,prefix){if(!prefix)prefix='N';var alphabet=narouCodeUtil.ALPHABET;var alphaLen=narouCodeUtil.ALPHA_LEN;var max=narouCodeUtil.MAX_NUMBER;var alphaArray=[];var div=num/max|0;var numPart=num%max||max;if(numPart==max)div-=1;do{alphaArray.push(alphabet.substr(div%alphaLen,1));div=div/alphaLen|0;}while(div);return prefix+narouCodeUtil.paddingZero(numPart)+alphaArray.reverse().join('');}