/*********************************************************************
 * 『なろう検索』小説家になろうグループ検索用スクリプト（初期値）
 *********************************************************************/
var initValues = {
	common : {
		showLatestVersion : false //作者サイトの最新バージョン情報を表示する：true、表示しない：false
		/*-------------------------------------------------------------*
		 *【除外する作者：検索結果から除外するユーザIDを、以下の形式で指定してください】
		 *
		 *  'ユーザID' : '注釈'
		 *
		 * ※注釈を設定しない場合は '' としてください。
		 * ※複数指定したい場合は半角カンマで区切って羅列してください。
		 * ※検索結果では「除外作者作品」とのみ表示されるようになります。
		 *-------------------------------------------------------------*/
		,hideUserids : {
		}
		/*-------------------------------------------------------------*
		 *【注目する作者：検索結果で注目するユーザIDを、以下の形式で指定してください】
		 *
		 *  'ユーザID' : '注釈'
		 *
		 * ※注釈を設定しない場合は '' としてください
		 * ※複数指定したい場合は半角カンマで区切って羅列してください。
		 * ※検索結果ではタイトル行の背景が淡黄色で表示されるようになります。
		 *-------------------------------------------------------------*/
		,hilightUserids : {
		}
		/*-------------------------------------------------------------*
		 *【R18：除外する作者：R18サイトの検索結果で除外する作者名を、以下の形式で指定してください】
		 *
		 *  '作者名' : '注釈'
		 *
		 * ※注釈を設定しない場合は '' としてください
		 * ※複数指定したい場合は半角カンマで区切って羅列してください。
		 * ※R18サイトの検索結果では、ユーザIDやXIDが含まれないための機能です。
		 * ※同名作者の作品も対象になるので、あくまで参考情報として、最終的にはご自分で確認してください。
		 * ※検索結果では全体が淡色で表示されるようになります。
		 *-------------------------------------------------------------*/
		,hideUserNames : {
		}
		/*-------------------------------------------------------------*
		 *【R18：注目する作者：R18サイトの検索結果で注目する作者名を、以下の形式で指定してください】
		 *
		 *  '作者名' : '注釈'
		 *
		 * ※注釈を設定しない場合は '' としてください
		 * ※複数指定したい場合は半角カンマで区切って羅列してください。
		 * ※R18サイトの検索結果では、ユーザIDやXIDが含まれないための機能です。
		 * ※同名作者の作品も対象になるので、あくまで参考情報として、最終的にはご自分で確認してください。
		 * ※検索結果ではタイトル行の背景が淡橙色で表示されるようになります。
		 *-------------------------------------------------------------*/
		,hilightUserNames : {
		}
	}
	/* ■■■■■■■■■■■■■■■■■■■■■■ *
	 *【なろう検索／なろうランキング検索　共通設定】
	 * ■■■■■■■■■■■■■■■■■■■■■■ */
	,search : {
		list : {
			/*-------------------------------------------------------------*
			 *【キーワード候補の文字列を、配列で指定してください】
			 * 以下の指定は、ある時点の公式の検索ページで、
			 * よく使われるキーワードとして掲載されていた語を使ったサンプルです。
			 *-------------------------------------------------------------*/
			word : [
				 'ハッピーエンド'
				,'魔法'
				,'バッドエンド ダーク' //このように半角スペースで区切って複数の語を記載することもできます
				,'復讐'
				,'転生'
				,'スキル ステータス'
			]
			/*-------------------------------------------------------------*
			 *【除外語候補の文字列を、配列で指定してください】
			 * 以下の指定は、ある時点の公式の検索ページで、
			 * よく使われるキーワードとして掲載されていた語を使ったサンプルです。
			 *-------------------------------------------------------------*/
			,notword : [
				 'ノンフィクション'
				,'メイド'
				,'ダンジョン'
				,'アンドロイド ロボット'
			]
		}
	/* ■■■■■■■■■■■■■■■■■■■■■■ *
	 *【なろう検索画面用設定】
	 * ■■■■■■■■■■■■■■■■■■■■■■ */
		/*-------------------------------------------------------------*
		 * 以下は、なろう検索画面の初期値の設定です。
		 * すべての項目ではありませんが、ここでの指定を変更することによって
		 * 初期表示時の値を変更することができます。
		 *
		 *【指定方法】
		 *  チェックボックス：チェックをつける場合はtrue、しない場合はfalseを指定
		 *  テキストボックス：初期表示したい文字列を、'' または "" で囲んで指定
		 *  　　　　　　　　 （数字を指定する場合は '' や "" で囲まなくても可）
		 *-------------------------------------------------------------*/
		,values : {
			/* ******************************** *
			 *【抽出条件(基本)】
			 * ******************************** */
			//大ジャンル（対象）：全年齢用
			 biggenre : {
				 1 :false //恋愛
				,2 :false //ファンタジー
				,3 :false //文芸
				,4 :false //SF
				,98:false //ノンジャンル
				,99:false //その他
			}
			//ジャンル（対象）：全年齢用
			,genre : {
				 101 : false //異世界
				,102 : false //現実世界
				,201 : false //ハイファンタジー
				,202 : false //ローファンタジー
				,301 : false //純文学
				,302 : false //ヒューマンドラマ
				,303 : false //歴史
				,304 : false //推理
				,305 : false //ホラー
				,306 : false //アクション
				,307 : false //コメディー
				,401 : false //VRゲーム
				,402 : false //宇宙
				,403 : false //空想科学
				,404 : false //パニック
				,9801 : false //ノンジャンル
				,9901 : false //童話
				,9902 : false //詩
				,9903 : false //エッセイ
				,9904 : false //リプレイ
				,9999 : false //その他
			}
			//大ジャンル（除外）：全年齢用
			,notbiggenre : {
				 1 :false //恋愛
				,2 :false //ファンタジー
				,3 :false //文芸
				,4 :false //SF
				,98:false //ノンジャンル
				,99:false //その他
			}
			//ジャンル（除外）：全年齢用
			,notgenre : {
				 101 : false //異世界
				,102 : false //現実世界
				,201 : false //ハイファンタジー
				,202 : false //ローファンタジー
				,301 : false //純文学
				,302 : false //ヒューマンドラマ
				,303 : false //歴史
				,304 : false //推理
				,305 : false //ホラー
				,306 : false //アクション
				,307 : false //コメディー
				,401 : false //VRゲーム
				,402 : false //宇宙
				,403 : false //空想科学
				,404 : false //パニック
				,9801 : false //ノンジャンル
				,9901 : false //童話
				,9902 : false //詩
				,9903 : false //エッセイ
				,9904 : false //リプレイ
				,9999 : false //その他
			}
			//ジャンル（対象）：18禁用
			,nocgenre : {
				 1 :false //男性向け
				,2 :false //女性向け
				,3 :false //BL
			}
			//ジャンル（除外）：18禁用
			,notnocgenre : {
				 1 :false //男性向け
				,2 :false //女性向け
				,3 :false //BL
			}
			//登録必須キーワード（対象）
			,isr15     :{ 1:false } //R15
			,isbl      :{ 1:false } //ボーイズラブ
			,isgl      :{ 1:false } //ガールズラブ
			,iszankoku :{ 1:false } //残酷な描写あり
			,istensei  :{ 1:false } //異世界転移
			,istenni   :{ 1:false } //異世界転生
			//登録必須キーワード（除外）
			,notr15     :{ 1:false } //R15
			,notbl      :{ 1:false } //ボーイズラブ
			,notgl      :{ 1:false } //ガールズラブ
			,notzankoku :{ 1:false } //残酷な描写あり
			,nottensei  :{ 1:false } //異世界転移
			,nottenni   :{ 1:false } //異世界転生
			/* ******************************** *
			 *【抽出条件(詳細)】
			 * ******************************** */
			//検索語（キーワード）
			,word : ''
			//検索語（除外語）
			,notword : ''
			//検索語（比較対象）
			,title  : { 1:false } //小説名
			,ex     : { 1:false } //あらすじ
			,keyword: { 1:false } //キーワード
			,wname  : { 1:false } //作者名
			//文字数
			,minlen : ''
			,maxlen : ''
			//読了時間（最短）
			,id_mintime_dd : '' //日
			,id_mintime_hh : '' //時間
			,id_mintime_mn : '' //分
			//読了時間（最長）
			,id_maxtime_dd : '' //日
			,id_maxtime_hh : '' //時間
			,id_maxtime_mn : '' //分
			/* ******************************** *
			 *【取得形式】
			 * ******************************** */
			//最大件数（1～100の範囲で指定）
			,lim : '20'
			//取得項目
			,of : {
				 nu:false //最終更新日時
				,ti:false //読了時間
				,gp:false //総合ポイント
				,dp:false //日間ポイント
				,wp:false //週間ポイント
				,mp:false //月間ポイント
				,qp:false //四半期ポイント
				,yp:false //年間ポイント
				,imp:false //感想数
				,f :false //ブックマーク数
				,r :false //レビュー数
				,a :false //評価点
				,ah:false //評価者数
				,sa:false //挿絵数
				,ka:false //会話率
			}
			//オプション
			,opt : {
				weekly:false //週間ユニークユーザ数
			}
			//1分あたりの読了字数（100～1000の範囲で指定）
			,id_minute_by_minute : 500
			/* ******************************** *
			 * 表示オプション
			 * ******************************** */
			//計算項目
			,id_calc_convert_page_count  : { 1:true } //5,000字換算話数
			,id_calc_gpoint : { 1:true } //総合ポイント
			//リンク
			,id_first_page  : { 1:true } //連載の第1話
			,id_last_page   : { 1:true } //連載の最新話
			,id_rss_page    : { 1:true } //RSSフィード
			,id_analyze_page: { 1:true } //アクセス解析
			//RSSフィードの種類
			,id_rss_kind_selector : "RSS_URL,RSS_BLOG_URL" //小説=RSS_URL、活動報告=RSS_BLOG_URL、両方=RSS_URL,RSS_BLOG_URL
			//あらすじポップアップ
			,id_popup_story_yes : { yes:true }
			//作者
				//除外する作者の作品を非表示
				,id_writer_hide : { 1:true }
				//注目する作者の作品をハイライト
				,id_writer_hilight : { 1:true }
			//総合ポイント
				,id_fail_global_point_hide : { 1:true }
				,id_fail_global_point : 0 //表示する総合ポイントの下限
			//評価
				//指定した平均評価点未満の作品を非表示。0.0～10.0の間で指定
				,id_fail_ave_hide : { 1:true }
				,id_fail_ave_decimal : 0 //表示する平均評価点の下限（整数）
				,id_fail_ave_point   : 0 //表示する平均評価点の下限（小数点数）
				//指定した評価人数未満の作品を非表示
				,id_fail_count_people_hide : { 1:true }
				,id_fail_count_people : 0 //表示する評価人数の下限
			//連載作品
				,id_only_unfinished : { 1:true } //以下の条件について、完結作品を除く
				//指定した話数未満の作品を非表示
				,id_fail_count_page_hide : { 1:true }
				,id_fail_count_page : 0 //表示する話数の下限
				//一話平均が指定した字数未満の作品を非表示
				,id_fail_ave_letter_rensai_hide : { 1:true }
				,id_fail_ave_letter_rensai : 0 //表示する一話平均字数の下限
		}
	}
	/* ■■■■■■■■■■■■■■■■■■■■■■ *
	 *【なろうランキング検索画面用設定】
	 * ■■■■■■■■■■■■■■■■■■■■■■ */
	,ranking : {
		/*-------------------------------------------------------------*
		 * 以下は、なろうランキング検索画面の初期値の設定です。
		 * すべての項目ではありませんが、ここでの指定を変更することによって
		 * 初期表示時の値を変更することができます。
		 *
		 *【指定方法】
		 *  チェックボックス：チェックをつける場合はtrue、しない場合はfalseを指定
		 *  テキストボックス：初期表示したい文字列を、'' または "" で囲んで指定
		 *  　　　　　　　　 （数字を指定する場合は '' や "" で囲まなくても可）
		 *-------------------------------------------------------------*/
		 values : {
			/* ******************************** *
			 *【抽出条件(基本)】
			 * ******************************** */
			//最大件数（10、20、30、40、50、60、70、80、90、100のいずれかを、'' または "" で囲んで指定）
			 max_count : '20'
			//大ジャンル（対象）：全年齢用
			,biggenre : {
				 1 :false //恋愛
				,2 :false //ファンタジー
				,3 :false //文芸
				,4 :false //SF
				,98:false //ノンジャンル
				,99:false //その他
			}
			//ジャンル（対象）：全年齢用
			,genre : {
				 101 : false //異世界'
				,102 : false //現実世界'
				,201 : false //ハイファンタジー'
				,202 : false //ローファンタジー'
				,301 : false //純文学'
				,302 : false //ヒューマンドラマ'
				,303 : false //歴史'
				,304 : false //推理'
				,305 : false //ホラー'
				,306 : false //アクション'
				,307 : false //コメディー'
				,401 : false //VRゲーム'
				,402 : false //宇宙'
				,403 : false //空想科学'
				,404 : false //パニック'
				,9801 : false //ノンジャンル'
				,9901 : false //童話'
				,9902 : false //詩'
				,9903 : false //エッセイ'
				,9904 : false //リプレイ'
				,9999 : false //その他'
			}
			//大ジャンル（除外）：全年齢用
			,notbiggenre : {
				 1 :false //恋愛
				,2 :false //ファンタジー
				,3 :false //文芸
				,4 :false //SF
				,98:false //ノンジャンル
				,99:false //その他
			}
			//ジャンル（除外）：全年齢用
			,notgenre : {
				 101 : false //異世界'
				,102 : false //現実世界'
				,201 : false //ハイファンタジー'
				,202 : false //ローファンタジー'
				,301 : false //純文学'
				,302 : false //ヒューマンドラマ'
				,303 : false //歴史'
				,304 : false //推理'
				,305 : false //ホラー'
				,306 : false //アクション'
				,307 : false //コメディー'
				,401 : false //VRゲーム'
				,402 : false //宇宙'
				,403 : false //空想科学'
				,404 : false //パニック'
				,9801 : false //ノンジャンル'
				,9901 : false //童話'
				,9902 : false //詩'
				,9903 : false //エッセイ'
				,9904 : false //リプレイ'
				,9999 : false //その他'
			}
			//登録必須キーワード（対象）
			,isr15     :{ 1:false } //R15
			,isbl      :{ 1:false } //ボーイズラブ
			,isgl      :{ 1:false } //ガールズラブ
			,iszankoku :{ 1:false } //残酷な描写あり
			,istensei  :{ 1:false } //異世界転移
			,istenni   :{ 1:false } //異世界転生
			//登録必須キーワード（除外）
			,notr15     :{ 1:false } //R15
			,notbl      :{ 1:false } //ボーイズラブ
			,notgl      :{ 1:false } //ガールズラブ
			,notzankoku :{ 1:false } //残酷な描写あり
			,nottensei  :{ 1:false } //異世界転移
			,nottenni   :{ 1:false } //異世界転生
			/* ******************************** *
			 *【抽出条件(詳細)】
			 * ******************************** */
			//検索語（キーワード）
			,word : ''
			//検索語（除外語）
			,notword : ''
			//検索語（比較対象）
			,title  : { 1:false } //小説名
			,ex     : { 1:false } //あらすじ
			,keyword: { 1:false } //キーワード
			,wname  : { 1:false } //作者名
			//文字数
			,minlen : ''
			,maxlen : ''
			/* ******************************** *
			 *【取得形式】
			 * ******************************** */
			//取得項目
			,of : {
				 nu:false //最終更新日時
				,ti:false //読了時間
				,gp:false //総合ポイント
				,dp:false //日間ポイント
				,wp:false //週間ポイント
				,mp:false //月間ポイント
				,qp:false //四半期ポイント
				,yp:false //年間ポイント
				,imp:false //感想数
				,f :false //ブックマーク数
				,r :false //レビュー数
				,a :false //評価点
				,ah:false //評価者数
				,sa:false //挿絵数
				,ka:false //会話率
			}
			//オプション
			,opt : {
				weekly:false //週間ユニークユーザ数
			}
			//1分あたりの読了字数（100～1000の範囲で指定）
			,id_minute_by_minute : 500
			/* ******************************** *
			 * 表示オプション
			 * ******************************** */
			//計算項目
			,id_calc_convert_page_count  : { 1:true } //5,000字換算話数
			,id_calc_gpoint : { 1:true } //総合ポイント
			//リンク
			,id_first_page  : { 1:true } //連載の第1話
			,id_last_page   : { 1:true } //連載の最新話
			,id_rss_page    : { 1:true } //RSSフィード
			,id_analyze_page: { 1:true } //アクセス解析
			//RSSフィードの種類
			,id_rss_kind_selector : "RSS_URL,RSS_BLOG_URL" //小説=RSS_URL、活動報告=RSS_BLOG_URL、両方=RSS_URL,RSS_BLOG_URL
			//あらすじポップアップ
			,id_popup_story_yes : { yes:true }
			//作者
				//除外する作者の作品を非表示
				,id_writer_hide : { 1:true }
				//注目する作者の作品をハイライト
				,id_writer_hilight : { 1:true }
			//総合ポイント
				,id_fail_global_point_hide : { 1:true }
				,id_fail_global_point : 0 //表示する総合ポイントの下限
			//評価
				//指定した平均評価点未満の作品を非表示。0.0～10.0の間で指定
				,id_fail_ave_hide : { 1:true }
				,id_fail_ave_decimal : 0 //表示する平均評価点の下限（整数）
				,id_fail_ave_point   : 0 //表示する平均評価点の下限（小数点数）
				//指定した評価人数未満の作品を非表示
				,id_fail_count_people_hide : { 1:true }
				,id_fail_count_people : 0 //表示する評価人数の下限
			//連載作品
				,id_only_unfinished : { 1:true } //以下の条件について、完結作品を除く
				//指定した話数未満の作品を非表示
				,id_fail_count_page_hide : { 1:true }
				,id_fail_count_page : 0 //表示する話数の下限
				//一話平均が指定した字数未満の作品を非表示
				,id_fail_ave_letter_rensai_hide : { 1:true }
				,id_fail_ave_letter_rensai : 0 //表示する一話平均字数の下限
		}
	}
}
